#!/usr/bin/env python
#coding=utf-8
# a class of completion
import pygtk
import gobject
import gtk
class Completion:
    def __init__(self,Entry,model):
        self.comp= gtk.EntryCompletion()
        Entry.set_completion(self.comp)
        self.comp.set_match_func(self.match_func)
        self.comp.connect("match-selected",self.on_completion_match)
        self.model=model
        self.comp.set_model(model)
        self.comp.set_text_column(0)
        self.Entry=Entry
        Entry.set_completion(self.comp)
        self.comp.set_inline_completion(False)
        self.comp.set_inline_selection(False)
        self.comp.set_popup_single_match(True)
    def get_comp_point(self):
        str=unicode(self.Entry.get_text())
        pos=self.Entry.get_position()
        pos1=max([str.rfind(" ",0,pos),str.rfind("-",0,pos),str.rfind("－",0,pos)])
        pos2=max([str.rfind(" \"",0,pos),str.rfind(" “",0,pos),str.rfind(" ”",0,pos)])
        pos3=max([str.rfind("\" ",0,pos),str.rfind("“ ",0,pos),str.rfind("” ",0,pos)])
        if pos2<pos3:
            return pos3
        else:
            return pos1+1
    def match_func(self, completion, key, iter):
        self.pos=self.get_comp_point()
        model = completion.get_model()
        text_to_comp=unicode(self.Entry.get_text())[self.pos:self.Entry.get_position()]
        try:
            return model[iter][0].startswith(text_to_comp)or model[iter][1].startswith(text_to_comp)
        except:
            return False
    def on_completion_match(self, completion, model, iter):
        str=unicode(self.Entry.get_text())
        self.Entry.set_text((str[:self.pos]+model[iter][0]+" "+str[self.Entry.get_position():]).decode("UTF8"))
        self.Entry.set_position(-1)
        return True
    def add_words(self, words):
        model = self.comp.get_model()
        for word in words:
            model.append([word])
